<template>
  <main>
    <mt-page-title
      :link-to="{ name: 'profil-dashboard-typedisponibilite', params: { profil: 'admin' } }"
      link-text="Annuler"
    >
      <h1 class="has-text-weight-bold is-size-3">Modification d'un type disponibilité</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-type-disponibilite :type-disponibilite="typeDisponibilite" />
      <div class="columns is-centered">
        <b-button type="is-primary has-text-weight-semibold" native-type="submit">
          Enregistrer les modifications
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import newTypeDisponibilite from '~/components/mixins/typeDisponibiliteMixin';
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormTypeDisponibilite from '~/components/dashboard/typedisponibilite/champs-form-typedisponibilite';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormTypeDisponibilite,
  },
  async asyncData(context) {
    const typeDisponibilite = Object.assign(
      newTypeDisponibilite(),
      await context.$api.typesDisponibilites.get(context.params.id),
    );
    return {
      typeDisponibilite,
    };
  },
  methods: {
    async submit() {
      try {
        await this.$api.typesDisponibilites.put(this.typeDisponibilite.id, this.typeDisponibilite);
        this.$router.push({ name: 'profil-dashboard-typedisponibilite', params: { profil: 'admin' } });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss"></style>
